'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

require('loud-rejection/register');

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ = require('./');

var _init = require('./init');

var _init2 = _interopRequireDefault(_init);

var _package = require('../package.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function onError(err) {
  console.log(err.stack);
}

_commander2.default.version(_package.version).description('ExtPlug plugin development kit.');

_commander2.default.command('init').description('Scaffold a new plugin in the current directory.').action(function () {
  (0, _init2.default)({}).catch(onError);
});

_commander2.default.command('bundle <entry> [output]').description('Bundle a plugin.').option('--minify', 'minify bundle output', false).action(function (entry, output, options) {
  (0, _.build)(_extends({}, options, {
    entry: entry,
    output: output
  })).then(function () {
    console.log(_chalk2.default.green('Compiled successfully.'));
  }).catch(function (errors) {
    console.log(_chalk2.default.red('Failed to compile.'));
    console.log();

    errors.forEach(function (err) {
      console.log(err.message);
    });
  });
});

_commander2.default.command('watch <entry> <output>').description('Bundle a plugin. Rebuild automatically when source files change.').action(function (entry, output) {
  (0, _.watch)({
    entry: entry,
    output: output
  });
});

_commander2.default.parse(process.argv);