'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.build = build;
exports.watch = watch;

var _fs = require('fs');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pify = require('pify');

var _pify2 = _interopRequireDefault(_pify);

var _tmp = require('tmp');

var _build = require('./build');

var _build2 = _interopRequireDefault(_build);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var pifyStream = function pifyStream(stream) {
  return new Promise(function (resolve, reject) {
    stream.on('end', resolve).on('error', reject);
  });
};

function build(_ref) {
  var entry = _ref.entry,
      output = _ref.output,
      opts = _objectWithoutProperties(_ref, ['entry', 'output']);

  if (output) {
    return (0, _build2.default)(_extends({}, opts, {
      entry: _path2.default.resolve(entry),
      output: output
    }));
  }

  return (0, _pify2.default)(_tmp.tmpName)().then(function (name) {
    return (0, _build2.default)(_extends({}, opts, {
      entry: _path2.default.resolve(entry),
      output: name + '.js'
    })).then(function () {
      return pifyStream((0, _fs.createReadStream)(name + '.js').pipe(process.stdout));
    }).then(function () {
      return (0, _pify2.default)(_fs.unlink)(name + '.js');
    });
  });
}

function watch(opts) {
  return build(_extends({}, opts, {
    watch: true
  }));
}