'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = watch;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _pify = require('pify');

var _pify2 = _interopRequireDefault(_pify);

var _randomString = require('random-string');

var _randomString2 = _interopRequireDefault(_randomString);

var _cors = require('cors');

var _cors2 = _interopRequireDefault(_cors);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevServer = require('webpack-dev-server');

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _addDevServerEntrypoints = require('webpack-dev-server/lib/util/addDevServerEntrypoints');

var _addDevServerEntrypoints2 = _interopRequireDefault(_addDevServerEntrypoints);

var _build = require('./build');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tmpdir = (0, _pify2.default)(_tmp2.default.dir);

function watch(_ref) {
  var entry = _ref.entry;

  var pluginId = JSON.stringify((0, _randomString2.default)({ length: 16 }));
  var entryPath = JSON.stringify(_path2.default.join(process.cwd(), entry));
  var moduleStub = '\n    import Plugin from \'extplug/Plugin\';\n    import ActualPlugin from ' + entryPath + ';\n\n    let instance;\n\n    const HotReloader = Plugin.extend({\n      name: \'Reloader for \' + ' + JSON.stringify(_path2.default.basename(entry)) + ',\n\n      init(id, ext) {\n        this._super(id, ext);\n\n        instance = this;\n      },\n\n      enable() {\n        console.info(\'Enabling\', ActualPlugin);\n        this.actual = new ActualPlugin(' + pluginId + ', this.ext);\n        this.actual.enable();\n      },\n      disable() {\n        console.info(\'Disabling\', this.actual.constructor);\n        this.actual.disable();\n      }\n    });\n\n    if (module.hot) {\n      module.hot.accept(' + entryPath + ', () => {\n        console.info(\'Reloading\', ActualPlugin)\n        instance && instance.refresh();\n      });\n    }\n\n    export default Plugin;\n  ';

  return tmpdir().then(function (dir) {
    var stubPath = _path2.default.join(dir, 'stub.js');
    return (0, _pify2.default)(_fs2.default.writeFile)(stubPath, moduleStub).then(function () {
      var config = (0, _build.createWebpackConfig)({
        entry: stubPath,
        output: _path2.default.join(dir, 'output.js'),
        watch: true
      });

      config.output.publicPath = '/bundle.js';
      var serverConf = {
        hot: true,
        host: 'localhost',
        port: 8458,

        setup: function setup(app) {
          app.use((0, _cors2.default)());
        }
      };
      config.devServer = serverConf;
      config.plugins.push(new _webpack2.default.HotModuleReplacementPlugin());

      (0, _addDevServerEntrypoints2.default)(config, serverConf);

      config.entry = config.entry.map(function (name) {
        return name.startsWith('webpack/') ? require.resolve(name) : name;
      });

      var compiler = (0, _webpack2.default)(config);

      var server = new _webpackDevServer2.default(compiler, serverConf);

      return (0, _pify2.default)(server.listen.bind(server))(serverConf.port).then(function () {
        return server;
      });
    });
  }).then(function (server) {
    console.log('Listening on port ' + server.listeningApp.address().port + '.');
  });
}
module.exports = exports['default'];